package de.hdm_stuttgart.mi.sda1.hiberjpa;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import de.hdm_stuttgart.mi.sda1.hiberjpa.model.Lecture;


/**
 * A simple Jpa 2.1 example
 * 
 */
public class ReadAllLecturesCriteriaDriver {

    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
       final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("jpa-update");
       
       final EntityManager em = emFactory.createEntityManager();
       
       {
          final EntityTransaction transaction = em.getTransaction();
          transaction.begin();
          
          final CriteriaBuilder cb = em.getCriteriaBuilder();
          final CriteriaQuery<Lecture> cq = cb.createQuery(Lecture.class);
          final Root<Lecture> rootEntry = cq.from(Lecture.class);
          final CriteriaQuery<Lecture> all = cq.select(rootEntry);
          final TypedQuery<Lecture> allQuery = em.createQuery(all);
          
          final List<Lecture> lectures = allQuery.getResultList();
          
          System.out.println(lectures.size() + " lecture(s) found:");
          
          lectures.forEach(System.out::println);
          
          transaction.commit();
       }
       
       em.close();
    }
}
