package de.hdm_stuttgart.mi.sda1.hiberjpa;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

import de.hdm_stuttgart.mi.sda1.hiberjpa.model.Lecture;


/**
 * A simple Jpa 2.1 query example
 * 
 */
public class ReadAllLecturesJpqlDriver {

    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
       final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("jpa-update");
       
       final EntityManager em = emFactory.createEntityManager();
       
       {
          final EntityTransaction transaction = em.getTransaction();
          transaction.begin();
          
          final TypedQuery<Lecture> allQuery = em.createQuery("from Lecture l where l.name like 'S%'", Lecture.class);
          
          final List<Lecture> lectures = allQuery.getResultList();
          
          System.out.println(lectures.size() + " lecture(s) found:");
          
          lectures.forEach(System.out::println);
          
          transaction.commit();
       }
       
       em.close();
    }
}
